import { Component as ReactComponent } from 'react';
import Constructor from './constructor';
declare type Owner = any;
/**
 * Memoizes the "KlassWithOwner" classes, so that only one is generated
 * for any given pair of Klass and owner. Otherwise, we generate a new
 * class for every render, which not only is bad for performance but also
 * breaks the way that the wrapper translates updates to props down to
 * the underlying React component.
 */
export default function grantOwnerAccess<T extends Constructor<ReactComponent>>(Klass: T, owner: Owner): Constructor<ReactComponent>;
export {};
